SystemOrganization addCategory: #SimpleLogger!

Object subclass: #LoggerStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleLogger'!

LoggerStrategy subclass: #FileLoggerStrategy
	instanceVariableNames: 'logFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleLogger'!

!FileLoggerStrategy commentStamp: 'GermanArduino 7/13/2010 19:41' prior: 0!
A G9Logger is a simple logger for Pharo/Squeak.

Developed by Germn S. Arduino on July 2010.

This product is MIT licensed.

Instance Variables
	logFile:		<Object>

logFile
	- xxxxx
!

!FileLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:26'!
closeLogFile 
	
	self 
		log: '------------------------------------------------------------------------------';
		log: self class name, ' ended at: ',TimeStamp now asString;
		log: '------------------------------------------------------------------------------'.
	
	self logFile close. 
	! !

!FileLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:47'!
createLogFile
	logFile := FileDirectory default forceNewFileNamed: self defaultFileName.
	self writeStartLog.
	! !

!FileLoggerStrategy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:44'!
defaultFileName
	^ TimeStamp now asString , '.txt'! !

!FileLoggerStrategy methodsFor: 'actions' stamp: 'GermanArduino 7/13/2010 19:38'!
log: anObject
	
	logFile nextPutAll: anObject, String crlf.
! !

!FileLoggerStrategy methodsFor: 'accessing' stamp: 'GermanArduino 7/13/2010 19:38'!
logFile
	^ logFile! !

!FileLoggerStrategy methodsFor: 'accessing' stamp: 'GermanArduino 7/13/2010 19:38'!
logFile: anObject
	logFile := anObject! !

!FileLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 2/2/2012 14:46'!
reopenStreamIfClosed
	(FileDirectory default fileExists: self defaultFileName)
		ifTrue: [ logFile := FileDirectory default oldFileNamed: self defaultFileName ]
		ifFalse: [ self createLogFile ]
	
! !

!FileLoggerStrategy methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 14:00'!
startLogging
	self createLogFile.! !

!FileLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 13:58'!
stopLogging
	self closeLogFile ! !

!FileLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:46'!
writeStartLog
	self
		log: '------------------------------------------------------------------------------';
		log: self class name , ' started at:  ' , TimeStamp now asString;
		log: '------------------------------------------------------------------------------'
	! !

FileLoggerStrategy subclass: #FixesFileNameLoggerStrategy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleLogger'!

!FixesFileNameLoggerStrategy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2010 14:38'!
named: aString
	^ self new fileName: aString! !

!FixesFileNameLoggerStrategy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:45'!
defaultFileName
	^ self fileName! !

!FixesFileNameLoggerStrategy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:45'!
fileName
	^ fileName! !

!FixesFileNameLoggerStrategy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:36'!
fileName: anObject
	fileName := anObject! !

!LoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:12'!
log: anObject
	
	self shouldBeImplemented! !

!LoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 2/2/2012 14:44'!
reopenStreamIfClosed
	"To be overriden if necessary"! !

!LoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:13'!
startLogging
	"To be overriden if necessary"! !

!LoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:13'!
stopLogging
	"To be overriden if necessary"! !

LoggerStrategy subclass: #NullLoggerStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleLogger'!

!NullLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:16'!
log: anObject
	"Does nothing"! !

LoggerStrategy subclass: #TranscriptLoggerStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleLogger'!

!TranscriptLoggerStrategy methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:16'!
log: anObject
	
	Transcript nextPutAll: anObject asString, String crlf; flush.
! !

Object subclass: #MyAppLogger
	instanceVariableNames: ''
	classVariableNames: 'MyAppLoggerHolder'
	poolDictionaries: ''
	category: 'SimpleLogger'!

!MyAppLogger class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/20/2010 14:58'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'MyApp.txt'). 
	logger startLogging.
	^ logger! !

!MyAppLogger class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2010 15:03'!
example
	MyAppLogger logger log: 'zaraza'
	"Actually the idae is that you can create a method *MyAppLogger in Object that does:
	log: anObject
		MyAppLogger logger log: anObject
	
	So after, everywhere in your app you can just do self log: 'something'.
	"
	! !

!MyAppLogger class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:58'!
logger
	MyAppLoggerHolder
		ifNil: [MyAppLoggerHolder := self createLogger].
	^ MyAppLoggerHolder! !

Object subclass: #SimpleLogger
	instanceVariableNames: 'strategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleLogger'!

!SimpleLogger class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/20/2010 14:28'!
example1
	| logger |
	logger := SimpleLogger new.
	logger startLogging.
	logger log: 'One line'; log: 'another line'.
	logger stopLogging.
	logger log: 'this is not'; log: 'logged'! !

!SimpleLogger class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/20/2010 14:29'!
example2
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new.
	logger startLogging.
	logger log: 'One line'; log: 'another line'.
	logger stopLogging.
	logger log: 'this is not'; log: 'logged'! !

!SimpleLogger class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/20/2010 14:48'!
example3
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'MyApp.txt'). 
	logger startLogging.
	logger log: 'One line'; log: 'another line'.
	logger stopLogging.
	logger log: 'this is not'; log: 'logged'.
	logger strategy: (FixesFileNameLoggerStrategy named: 'MyApp.txt'). 
	logger startLogging.
	logger log: 'This should have overriden'; log: ' the other file'.
	logger stopLogging.! !

!SimpleLogger methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 13:59'!
initialize
	super initialize.
	self strategy: FileLoggerStrategy new.! !

!SimpleLogger methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 13:55'!
log: anObject
	self strategy log: anObject! !

!SimpleLogger methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 13:54'!
logSeparator
	
	self log: '------------------------------------------------------------------------------'.! !

!SimpleLogger methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 13:54'!
logWithTimeStamp: anObject
	
	self log: (anObject,' ',TimeStamp now asString, String crlf).
! !

!SimpleLogger methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/2/2012 14:44'!
reopenStreamIfClosed
	strategy reopenStreamIfClosed! !

!SimpleLogger methodsFor: 'actions' stamp: 'MarianoMartinezPeck 10/20/2010 14:00'!
startLogging 
	self strategy startLogging. ! !

!SimpleLogger methodsFor: 'actions' stamp: 'MarianoMartinezPeck 1/14/2011 12:02'!
stopLogging
	self strategy stopLogging. ! !

!SimpleLogger methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:20'!
strategy
	^ strategy! !

!SimpleLogger methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 14:20'!
strategy: anObject
	strategy := anObject! !
